# Source: https://argo-cd.readthedocs.io/en/stable/user-guide/application-specification/
apiVersion: argoproj.io/v1alpha1
kind: Application
metadata:
  name: kube-prometheus-stack
  namespace: argocd
  finalizers:
    # Enable the default behaviour of foreground cascading deletion
    - resources-finalizer.argocd.argoproj.io  
spec:
  project: system
  sources:
  - repoURL: 'https://prometheus-community.github.io/helm-charts'
    chart: 'monitoring'
    targetRevision: 55.5.0
    helm:
      valueFiles:
        - $values_file/helm/values/kube-prometheus-stack.yaml
  - repoURL: 'https://gitlab.com/devops-johnfli/assignments/swissborg'
    ref: values_file
    targetRevision: main
  destination:
    server: "https://kubernetes.default.svc"
    namespace: monitoring
  syncPolicy:
    automated: # automated sync by default retries failed attempts 5 times with following delays between attempts ( 5s, 10s, 20s, 40s, 80s ); retry controlled using `retry` field.
      prune: true # Specifies if resources should be pruned during auto-syncing ( false by default ).
      selfHeal: true # Specifies if partial app sync should be executed when resources are changed only in target Kubernetes cluster and no git change detected ( false by default ).
    syncOptions:     # Sync options which modifies sync behavior
    - CreateNamespace=true # Namespace Auto-Creation ensures that namespace specified as the application destination exists in the destination cluster.
